;************************************************************
;*** DMX RDM ***
;************************************************************

;*** equ Wahl fr test **************************************
.equ RDM_debug_test =0; 0=debug OFF 1=debug ON
;	rcall	RDM_test_array
;	rcall	RDM_auswertung
;************************************************************

;*** EQUs fr Main Programm ***********************************
;*** ins Main Programm ***

;*** RDM ***
;*** set_UID_adr:;6 Bytes
;.equ set_UID_0_adr = 0xd9;msb
;.equ set_UID_1_adr = 0x03
;.equ set_UID_2_adr = 0x00
;.equ set_UID_3_adr = 0x00
;.equ set_UID_4_adr = 0x00
;.equ set_UID_5_adr = 0x00;lsb

;.equ RDM_response_delay=14 ;bei 20 MHz
;.equ RDM_Befehls_ID_max=1  ;0=RDMmini 1=RDMmax	
;.equ RDM_auswertung_Bf_equ=0 ;0=bf_equ|1=lo_bf_equ	
;.equ RDM_cpu_select=0 ;0=Mega88 1=Tiny2313
;.equ DMX_footprint=9 ;Kanalbelegung LO
;*** RX/TX ->SN75176 (RE,DE)
;.equ port_RE_DE = portD;Port Wahl
;.equ pin_RE_DE = 4     ;Port NR
;***********************************************************

;***********************************************************
;*** Funktionen und Programm fr Main Programm  *************
	;*** INT ***
;	rjmp	RDM_USART_RXC: 	;USART, RX Complete Handler
;	rjmp    RDM_USART_TXC 	;USART, TX Complete Handler
	;*** rcall *** 
;	rcall	RDM_INI        ;in Reset
;	rcall   RDM_auswertung ;in bf_equ
;	rcall	RDM_response_TX;in bf_equ

;	RDM_timer_TX_delay;funktion macro fr timer
;	DMX_timeout_M;;funktion macro fr Low timer
;*************************************************************

;	*** ASM-macro ***
;	*** ASM fr timer INT *** RDM_timer_delay 176s->TX 
.macro  RDM_timer_TX_delay
	lds	temp0,RDM_timer_delay
	tst	temp0
	breq	tim0_no_RDM_timer_delay_M
	dec	temp0
	sts	RDM_timer_delay,temp0
	brne	tim0_no_RDM_timer_delay_M
;	* set funktion -> TX-out in 176s (14=179.2s)

.if RDM_auswertung_Bf_equ==0
	sbr	bf_equ,32;TX-out
.endif
.if RDM_auswertung_Bf_equ==1
	lds	temp0,bf_LO_mem	;set Flag fr RDM-TX
	sbr	temp0,32 ;RDM TX-out
	sts	bf_LO_mem,temp0;bf_LO_mem zurck ins MEM	
.endif

tim0_no_RDM_timer_delay_M:
.endm

;	*** ASM fr LO-timer ***
;	*** DMX timeout ->4ms*256~1s DMX-timeout ON ***
.macro	DMX_timeout_M
	lds	temp0,dmx_time_out
	inc	temp0;dmx_time_out
	sts	dmx_time_out,temp0
	brne	no_DMX_time_out_M

	lds	temp0,DMX_RDM_status
	sbr	temp0,1;Bit 0  time_out_dmx
	sts	DMX_RDM_status,temp0
no_DMX_time_out_M:
.endm ;DMX_timeout_M
	;*** DMX timeout ***


.if RDM_Befehls_ID_max==0
.equ RDM_data_max=24+32;(+2 Checksum)
.endif
.if RDM_Befehls_ID_max==1
.equ RDM_data_max=24+231;(+2 Checksum)
.endif

.dseg;*RAM ***************************************************
dmx_RDM_lo:	.byte 1	;DMX-RDMin counter 0..512
dmx_RDM_hi:	.byte 1 
old_dmx_lo:	.byte 1	;old DMXin counter 0..512
old_dmx_hi:	.byte 1 
dmx_adr_lo:	.byte 1	;DMX ADR  
dmx_adr_hi:	.byte 1  
DMX_RDM_ram_adr:.byte 2 ;DMX-RDM DATENram pointer
DMX_RDM_daten_count:.byte 1;anzahl DMXadressen/RDM Bytes 

dmx_start_adr:
dmx_start_adr_lo:.byte 1;eingestelle DMX ADR
dmx_start_adr_hi:.byte 1	
dmx_footprint_adr:.byte 1;anzahl DMXadressen

response_pointer:.byte 2;TX-pointer
response_counter:.byte 1;TX-Counter
DMX_time_out	:.byte 1;time-out counter
RDM_timer_delay: .byte 1;Delay RX->TX
DMX_RDM_status:	 .byte 1 ;0=time_out_dmx	
			 ;1=RXin 0:->DMX 1:->RDM 	
			 ;2=0:RDM ohne Break 1:RDM mit Break	
			 ;3=0:RDM Unmute 1:RDM mute	
			 ;4=RXin 0:->DMX 1:->anderes 	
			 ;5=	
			 ;6=	
			 ;7=
RDM_status:	 .byte 1 ;0=Identify State (0x1000)->Off/On (0/1)	
			 ;1=	
			 ;2=	
			 ;3=0:RDM Unmute 1:RDM mute	
			 ;4=	
			 ;5=	
			 ;6=IDENTIFY	
			 ;7=

UID_adr_mem:
UID_0_adr_mem:	.byte 1;0 msb
UID_1_adr_mem:	.byte 1;1
UID_2_adr_mem:	.byte 1;2
UID_3_adr_mem:	.byte 1;3
UID_4_adr_mem:	.byte 1;4
UID_5_adr_mem:	.byte 1;5 

;*** RDM in/out Buffer ***
DiscRespMsg_mem:
;preamble:	.byte 8;0
;encrypted_UID0:	.byte 2;8
;encrypted_UID1:	.byte 2;10
;encrypted_UID2:	.byte 2;12
;encrypted_UID3:	.byte 2;14
;encrypted_UID4:	.byte 2;16
;encrypted_UID5:	.byte 2;18
;encrypted_CS_HI:.byte 2;20 CS ber 8..18 Byte
;encrypted_CS_LO:.byte 2;22

RDM_puffer:	
RDM_Packet:	
RDM_ASC:	.byte 1 ;0  0xcc alternate start code
RDM_SSC:	.byte 1 ;1  0x01 sub start code
RDM_Length:     .byte 1 ;2  packet length
RDM_DestID:	.byte 6 ;3  target address(Zieladresse)
RDM_SrcID:	.byte 6 ;9  source manufacturer address(Quelladresse)
RDM_TransNo:	.byte 1 ;15 tranaction number
RDM_PortID:	.byte 1 ;16 Port ID / response type
RDM_MsgCount:	.byte 1 ;17 message count(Anzahl der wartenden Nachrichten)
RDM_SubDev:	.byte 2 ;18 sub device number (root = 0)
RDM_CmdCls:	.byte 1 ;20 command class(Befehlsart)
RDM_PID:	.byte 2 ;21 parameter ID
RDM_PDLen:	.byte 1 ;23 parameter data length in bytes

.if RDM_Befehls_ID_max==0
RDM_Data:	.byte 32;24..56 data byte field (0.. max 20 Byte)
.endif
.if RDM_Befehls_ID_max==1
RDM_Data:	.byte 231;24..56 data byte field (0.. max 231 Byte)
.endif

RDM_RDM_cs:	.byte 2 ;   Check Summe	

RDM_reseve:	.byte 2




.eseg;* EEROM ********************************************

;* RDM
ee_UID_adr:;6 Bytes
ee_UID_0_adr:	.db set_UID_0_adr;msb
ee_UID_1_adr:	.db set_UID_1_adr
ee_UID_2_adr:	.db set_UID_2_adr
ee_UID_3_adr:	.db set_UID_3_adr
ee_UID_4_adr:	.db set_UID_4_adr
ee_UID_5_adr:	.db set_UID_5_adr;lsb
;***
ee_InfoMsg_len:
.db	19 ;Bytes	    	
ee_InfoMsg:         ;19(0x13) Bytes  device info msg
.db	1, 0	    ;0  RDM protocol version
.db     1, 0	    ;2  device model ID
.db     0x05,0x09   ;4  fixture type(Gerte type product category)
.db     0, 0, 1, 1  ;6  firmware version
ee_DMX_footprint_adr:
.db     0,DMX_footprint;10 DMX footprint(Kanalbelegung HI,LO)
.db     1, 1	    ;12 current DMX personality				
ee_DMX_start_adr:
.db     0, 1	    ;14 DMX start address(HI,LO)
.db     0, 0	    ;16 no of sub devices
.db     0	    ;18 no of sensors 
;***

;******
.if RDM_Befehls_ID_max==0
;******

ee_SUPPORTED_PARAMETERS_len:
.db	8 ;Byte
ee_SUPPORTED_PARAMETERS:;6 Bytes
.db 0x00,0xF0;DMX_START_ADDRESS
.db 0x00,0x60;MANUFACT_LABEL
.db 0x00,0x50;DEVICE_INFO
.db 0x00,0x82;DEVICE_LABEL
;***
ee_DEVICE_LABEL_len:
.db	32 ;Bytes
ee_DEVICE_LABEL:;32 Byte max
.db	"01234567890123456789012345678901"	
;******
.endif ;RDM_Befehls_ID_max
;******

;******************************
.if RDM_Befehls_ID_max==1
;******************************

ee_MANUFACT_LABEL_len:
.db	32 ;Bytes
ee_MANUFACT_LABEL:;32 Byte max
.db	"01234567890123456789012345678901"	
;***
ee_SUPPORTED_PARAMETERS_len:
.db	12 ;Bytes
ee_SUPPORTED_PARAMETERS:;12 Bytes
.db 0x00,0x82;DEVICE_LABEL
.db 0x00,0xF0;DMX_START_ADDRESS
.db 0x00,0x81;MANUFACT_LABEL
.db 0x00,0x50;SUPPORTED_PARAMETERS
.db 0x00,0xc0;SOFTWARE_VERSION_LABEL
.db 0x00,0x60;DEVICE_INFO
;***
ee_StatusMsg_len:
.db	9 ;Bytes
ee_StatusMsg: ;9 Byte
.db 0x00,0x00;sub device ID
.db 0x00,0x00;device state STATUS_NONE		(0x00)
	     ;             STATUS_GET_LAST_MSG	(0x01)
	     ;		   STATUS_WARNING	(0x03)
	     ;		   STATUS_ERROR		(0x04)
.db 0x00     ;error ID	
.db 0xff,0xff;Parameter 1(SD_UNDEFINED(FFFF))
.db 0x00,0x00;Parameter 2

ee_SOFTWARE_VERSION_LABEL_len:
.db 32 ;Bytes
ee_SOFTWARE_VERSION_LABEL:;32 Byte max
.db	"01234567890123456789012345678901"	

ee_STATUS_ID_DESCRIPTION_len:
.db 32 ;Bytes
ee_STATUS_ID_DESCRIPTION:;32 Byte max
.db	"01234567890123456789012345678901"	


;******************************
.endif ;RDM_Befehls_ID_max
;******************************




.cseg;***************************************************


DiscRespMsg:                         ;discovery response msg
.db 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xFE, 0xAA ;preamble
UID_0: .db 0xAA,0x55                 ;encrypted UID					
UID_1: .db 0xAA,0x55		
UID_2: .db 0xAA,0x55	
UID_3: .db 0xAA,0x55	
UID_4: .db 0xAA,0x55	
UID_5: .db 0xAA,0x55		
UID_CS_H: .db 0xAA,0x55
UID_CS_L: .db 0xAA,0x55
.db 0x65,0x48,0x6d,0x6c
.db 0x72,0x61,0x69,0x5a
.db 0x6b,0x6c,0x21,0x65
.db 0x32,0x30,0x31,0x36
;*******************************************************
.if RDM_debug_test==1
RDM_test_Packet:
.db 0xcc,0x01
.




.endif
;*******************************************************

;*** RDM ***********************************************
;//parameter IDs
;discovery   (0x10)
;*** DISC_UNIQUE_BRANCH		(0x0001) //network management
;*** DISC_MUTE			(0x0002) sonder Funktion : NEW UID_adr
;*** DISC_UN_MUTE		(0x0003)

;GET	(0x20)
;*** DEVICE_INFO		(0x0060) DMX Startadr,kanalbelegung,GerteTyp
;*** DMX_START_ADDRESS		(0x00F0) DMX setup Startadr
;*** SUPPORTED_PARAMETERS	(0x0050) Funktionen information
;MANUFACT_LABEL               	(0x0081)
;DEVICE_LABEL			(0x0082)
;SOFTWARE_VERSION_LABEL		(0x00C0)
;STATUS_ID_DESCRIPTION 		(0x0031)
;STATUS_MESSAGES		(0x0030)
;IDENTIFY                       (0x1000)
;SENSOR_VALUE                   (0x0201)
;Sonder ich
;Daten_info			(0x8010);Daten:AD IR DMX ... 

;SET   (0x30)
;*** DMX_START_ADDRESS		(0x00F0)
;MANUFACT_LABEL               	(0x0081)
;DEVICE_LABEL			(0x0082)
;SOFTWARE_VERSION_LABEL		(0x00C0)
;IDENTIFY                       (0x1000)


;anderes
;DEVICE_HOURS                   (0x0004)
;PARAMETER_DESCRIPTION	        (0x0051)
;PERSONALITY                    (0x00E0)
;ERR_SCENE			(0x0302)
;DIMMSWITCH			(0x0304)

;sonder Funktion
;GET (0x20)
;mem_info 			(0x8200)
;DMX_info			(0x8201)
;IR_info			(0x8210)
;ADC_info			(0x8220)
;max_DIM			(0x8280)

;SET (0x30)
;max_DIM			(0x8280)

RDM_auswertung:
	;test SC_SUB_MESSAGE
	lds	temp0,RDM_SSC
	cpi	temp0,0x01;test SC_SUB_MESSAGE
	brne	RDM_auswertung_end

	rcall	check_sum
	;check-sum vergleichen
	ld	temp0,x+
	cp	temp5,temp0
	brne	RDM_auswertung_end
	ld	temp0,x+
	cp	temp4,temp0
	brne	RDM_auswertung_end
	;check-sum vergleich OK
	;check RDM_PortID
	lds	temp0,RDM_PortID;Port ID / response type
	cpi	temp0,0x00
	breq	RDM_auswertung_end
	;check-Port ID OK
	;Auswertung
	lds	temp0,RDM_CmdCls
	lds	temp2,RDM_PID+0
	lds	temp3,RDM_PID+1

	cpi	temp0,0x10 ;DISC_CMD(10)
	brne	not_DISC_CMD
	rjmp	DISC_CMD	
not_DISC_CMD:
	rcall	test_UID_adr
	brne	RDM_auswertung_end;falsche UID-adr	

	cpi	temp0,0x20 ;GET_CMD(20)
	brne	not_GET_CMD
	rjmp	GET_CMD
not_GET_CMD:
	cpi	temp0,0x30 ;SET_CMD(30)
	brne	not_SET_CMD
	rjmp	SET_CMD
not_SET_CMD:
	;andere Funktionen

RDM_auswertung_end:

	ret 
;*************************************************
;*** select DISC_CMD 0x10 ***
DISC_CMD:
	cpi	temp2,0x00;erste Byte auf null testen
	brne	DISC_CMD_end	

	cpi	temp3,0x01 ;0001 RDM_Device_discovery(DISC_UNIQUE_BRANCH)
	brne	not_RDM_Device_discovery
	rjmp	RDM_Device_discovery
not_RDM_Device_discovery:
	cpi	temp3,0x02;0002 RDM_Mute
	brne	not_RDM_Mute
	rjmp	RDM_Mute
not_RDM_Mute:
	cpi	temp3,0x03;0003 RDM_unMute
	brne	not_RDM_unMute
	rjmp	RDM_unMute
not_RDM_unMute:

.if RDM_Befehls_ID_max==1
	;andere Funktionen
.endif ;RDM_Befehls_ID_max

DISC_CMD_end:

	rjmp	PID_not_supported

;*************************************************
;*** select GET_CMD 0x20 (info holen) ***
GET_CMD:;20
	cpi	temp2,0x00;zweite Byte auf null testen
.if RDM_Befehls_ID_max==0
	brne	GET_CMD_end	
.endif
.if RDM_Befehls_ID_max==1
	brne	GET_CMD_00xx_end	
.endif

	cpi	temp3,0x60;DEVICE_INFO       	(0x0060)
	brne	not_RDM_DEVICE_INFO
	rjmp	RDM_DEVICE_INFO
not_RDM_DEVICE_INFO:
	cpi	temp3,0xF0;DMX_START_ADDRESS 	(0x00F0)
	brne	not_DMX_START_ADDRESS
	rjmp	DMX_START_ADDRESS
not_DMX_START_ADDRESS:
	cpi	temp3,0x50;SUPPORTED_PARAMETERS (0x0050)
	brne	not_SUPPORTED_PARAMETERS
	rjmp	SUPPORTED_PARAMETERS
not_SUPPORTED_PARAMETERS:	
	cpi	temp3,0x82;DEVICE_LABEL		(0x0082)
	brne	not_DEVICE_LABEL
	rjmp	DEVICE_LABEL
not_DEVICE_LABEL:

.if RDM_Befehls_ID_max==1

	cpi	temp3,0x81;MANUFACT_LABEL    	(0x0081)
	brne	not_MANUFACT_LABEL
	rjmp	MANUFACT_LABEL
not_MANUFACT_LABEL:
	cpi	temp3,0xc0;SOFTWARE_VERSION_LABEL(0x00C0)
	brne	not_SOFTWARE_VERSION_LABEL
	rjmp	SOFTWARE_VERSION_LABEL
not_SOFTWARE_VERSION_LABEL:
	cpi	temp3,0x31;STATUS_ID_DESCRIPTION (0x0031)
	brne	not_STATUS_ID_DESCRIPTION
	rjmp	get_STATUS_ID_DESCRIPTION
not_STATUS_ID_DESCRIPTION:
	cpi	temp3,0x30;STATUS_MESSAGES	(0x0030)
	brne	not_STATUS_MESSAGES
	rjmp	get_STATUS_MESSAGES
not_STATUS_MESSAGES:	

	;andere Funktionen 00xx


GET_CMD_00xx_end:

	cpi	temp2,0x10;high byte
	brne	not_IDENTIFY	
	cpi	temp3,0x00;lo byte
	brne	not_IDENTIFY	
	rjmp	get_IDENTIFY;IDENTIFY (0x1000)	
not_IDENTIFY:
	cpi	temp2,0x02;high byte
	brne	not_SENSOR_VALUE	
	cpi	temp3,0x01;lo byte
	brne	not_SENSOR_VALUE	
	rjmp	get_SENSOR_VALUE;SENSOR_VALUE (0x0201)	
not_SENSOR_VALUE:

	;andere Funktionen xxxx

.endif ;RDM_Befehls_ID_max

GET_CMD_end:

	rjmp	PID_not_supported
;*************************************************
;*** select SET_CMD 0x30 ***
SET_CMD:;30
	cpi	temp2,0x00;auf null testen
.if RDM_Befehls_ID_max==0
	brne	SET_CMD_end	
.endif
.if RDM_Befehls_ID_max==1
	brne	SET_CMD_00xx_end	
.endif

	cpi	temp3,0xF0;set DMX_START_ADDRESS(0x00F0)
	brne	not_set_DMX_START_ADDRESS
	rjmp	set_DMX_START_ADDRESS
not_set_DMX_START_ADDRESS:
	cpi	temp3,0x82;set DEVICE_LABEL	(0x0082)
	brne	not_set_DEVICE_LABEL
	rjmp	set_DEVICE_LABEL
not_set_DEVICE_LABEL:	


.if RDM_Befehls_ID_max==1

	cpi	temp3,0x81;set MANUFACT_LABEL  	(0x0081)
	brne	not_set_MANUFACT_LABEL
	rjmp	set_MANUFACT_LABEL
not_set_MANUFACT_LABEL:
	cpi	temp3,0xc0;set_SOFTWARE_VERSION_LABEL (0x00c0)
	brne	not_set_SOFTWARE_VERSION_LABEL
	rjmp	set_SOFTWARE_VERSION_LABEL
not_set_SOFTWARE_VERSION_LABEL:
	;andere Funktionen 00xx

SET_CMD_00xx_end:	
	cpi	temp2,0x10;high byte
	brne	not_IDENTIFY	
	cpi	temp3,0x00;lo byte
	brne	not_set_IDENTIFY	
	rjmp	set_IDENTIFY	
not_set_IDENTIFY:

	;andere Funktionen


.endif ;RDM_Befehls_ID_max

SET_CMD_end:

	rjmp	PID_not_supported
;************************************************
;*** RDM_Mute DISC_CMD 0x10 0x0002 ***
;* sonder Funktion :set NEW UID_adr ber RDM_Data 0..5
RDM_Mute:;10 0002
	rcall	test_UID_adr;set Z ???
	brne	RDM_Mute_end;falsche UID-adr	

	;* RDMstatus
	lds	temp0,RDM_status
	sbr	temp0,8;Bit 3  set RDM mute
	sts	RDM_status,temp0

	;*** sonder Funktion ***
	;Set new UID_adr ???
	lds	temp0,RDM_PDLen
	cpi	temp0,12
	brne	RDM_Mute_response;keine new UID_adr
	;* test new UID_adr
	ldi	yl,low(RDM_Data+0)
	ldi	yh,high(RDM_Data+0)
	ldi	temp3,6
RDM_Mute_test_rep:
	ldd	temp0,y+6
	ld	temp1,y+
	add	temp0,temp1
	inc	temp0
	brne	RDM_Mute_fehler
	dec	temp3
	brne	RDM_Mute_test_rep
	;test new UID_adr OK

	;*** new >>>UID_adr<<< ***
	ldi	yl,low(RDM_Data+0)
	ldi	yh,high(RDM_Data+0)
	ldi	xl,low(UID_adr_mem+0);Gerte ADR
	ldi	xh,high(UID_adr_mem+0);Gerte ADR
	ldi	temp3,6
RDM_Mute_rep:
	ld	temp0,y+
	st	x+,temp0
	dec	temp3
	brne	RDM_Mute_rep
	;*** set in ee new UID_adr ***
	ldi	temp3,6; = byte anzahl
	ldi	temp1,high(ee_UID_adr)
	ldi	temp0,low(ee_UID_adr); = EEPROM->ziel pointer 
	ldi	xh,high(UID_adr_mem);RDM_Data
	ldi	xl,low(UID_adr_mem); RDM_Data; = quelle Byte pointer
	rcall	EEPROM_write

//	rjmp	RDM_response_CmdCls_PDLen_break_PortID
RDM_Mute_response:
	ldi	temp0,0
	sts	RDM_Data+0,temp0
	sts	RDM_Data+1,temp0
	ldi	temp1,2
	sts	RDM_PDLen,temp1

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
RDM_Mute_fehler:
	rjmp	PID_not_supported;	ret
RDM_Mute_end:
	ret
;************************************************
;*** RDM_Mute DISC_CMD 0x10 0x0003 ***
RDM_unMute:;10 0003
	rcall	test_UID_adr_FF ;test FF.. set Z wenn gleich
	breq	RDM_unMute_set;FF ..UID-adr(alle)	

	rcall	test_UID_adr;UID_adr set Z wenn gleich
	brne	RDM_unMute_end

	;* RDMstatus
	lds	temp0,RDM_status
	cbr	temp0,8;Bit 3  set UID_adr RDM Unmute
	sts	RDM_status,temp0


	rjmp	RDM_Mute_response
RDM_unMute_set:
	;* RDMstatus
	lds	temp0,RDM_status
	cbr	temp0,8;Bit 3  set ALLE RDM Unmute
	sts	RDM_status,temp0
RDM_unMute_end:
	ret
;************************************************

;*************************************************
;*** Funktionen **********************************
;*** Device-discovery ***
RDM_Device_discovery:
	;* mute/unmute ???
	lds	temp0,RDM_status
	sbrc	temp0,3;Bit 3 ;0:unmute 1:mute
	rjmp	no_ISC_UNIQUE_BRANCH
	;* isLower
	ldi	xl,low(RDM_data+0) ;RDM_Packet UID LO
	ldi	xh,high(RDM_data+0);RDM_Packet
	ldi	yl,low(UID_adr_mem+0);Gerte ADR
	ldi	yh,high(UID_adr_mem+0);Gerte ADR
	ldi	temp3,6;byte
RDM_Device_discovery_isLower_rep:
	ld	temp0,x+;RDM_data
	ld	temp1,y+;UID_adr
	sub	temp1,temp0;vergleich auf kleiner,gleich
	rbrcs	no_ISC_UNIQUE_BRANCH
	brne	RDM_Device_discovery_isHigher
	dec	temp3
	brne	RDM_Device_discovery_isLower_rep
RDM_Device_discovery_isHigher:
	;* isHigher
	ldi	xl,low(RDM_data+6);RDM_Packet
	ldi	xh,high(RDM_data+6);RDM_Packet
	ldi	yl,low(UID_adr_mem+0)
	ldi	yh,high(UID_adr_mem+0)
	ldi	temp3,6
RDM_Device_discovery_isHigher_rep:
	ld	temp0,x+;RDM_data
	ld	temp1,y+;UID_adr
	sub	temp0,temp1;vergleich auf grer,gleich
	brcs	no_ISC_UNIQUE_BRANCH
	brne	RDM_Device_discovery_istest_ok
	dec	temp3
	brne	RDM_Device_discovery_isHigher_rep
RDM_Device_discovery_istest_ok:
	;* answer discovery msg
	ldi	xl,low(DiscRespMsg_mem)
	ldi	xh,high(DiscRespMsg_mem)

	ldi	zl,low(DiscRespMsg*2)
	ldi	zh,high(DiscRespMsg*2)
	;** preamble ** 
	ldi	temp4,8;byte 0..preamble
RDM_Device_discovery_1_msg_rep:
	LPM 	temp0, Z+
	st	x+,temp0	

	dec	temp4
	brne	RDM_Device_discovery_1_msg_rep

	ldi	yl,low(UID_adr_mem)
	ldi	yh,high(UID_adr_mem)
	;** encrypted UID **
	ldi	temp4,6;byte UID_0*2..UID_5*2
RDM_Device_discovery_2_msg_rep:
	LPM 	temp0, Z+
	ld	temp1,y
	or	temp0,temp1
	st	x+,temp0	
	LPM 	temp0, Z+
	ld	temp1,y+
	or	temp0,temp1
	st	x+,temp0
	dec	temp4	
	brne	RDM_Device_discovery_2_msg_rep
	;** Check-Summe **	
	ldi	yl,low(DiscRespMsg_mem+8)
	ldi	yh,high(DiscRespMsg_mem+8)
	ldi	temp2,0;CS ADD LO
	ldi	temp3,0;CS ADD HI
	ldi	temp1,0;NULL
	ldi	temp4,12;byte encrypted UID	
RDM_Device_discovery_3_msg_rep:
	ld	temp0,y+
	add	temp2,temp0
	adc	temp3,temp1;nur carry add	
	dec	temp4	
	brne	RDM_Device_discovery_3_msg_rep
	;** CHeck-Summe ->discovery response msg **
	LPM 	temp0, Z+
	or	temp0,temp3
	st	x+,temp0
	LPM 	temp0, Z+
	or	temp0,temp3
	st	x+,temp0
	LPM 	temp0, Z+
	or	temp0,temp2
	st	x+,temp0
	LPM 	temp0, Z+
	or	temp0,temp2
	st	x+,temp0
	;* TX-out response
	ldi	temp0,24;anzahl byte
	sts	response_counter,temp0
	ldi	temp0,low(DiscRespMsg_mem)
	sts	response_pointer+0,temp0
	ldi	temp0,high(DiscRespMsg_mem)
	sts	response_pointer+1,temp0
	
	ldi	temp0,RDM_response_delay;delay 179.2s ->TX
	sts	RDM_timer_delay,temp0

no_ISC_UNIQUE_BRANCH:
	ret
;***************************************************

;*** RDM_DEVICE_INFO
RDM_DEVICE_INFO:;(20 0060)
	ldi	temp3,19+1;legth InfoMsg +1
	ldi	temp1,high(ee_InfoMsg_len)
	ldi	temp0,low(ee_InfoMsg_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen) ;RDM_Data = ziel Byte pointer
	rcall	EEPROM_read

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** set_DMX_START_ADDRESS
set_DMX_START_ADDRESS:;(30 00F0)
	lds	temp3,RDM_PDLen;ParamMsg
	cpi	temp3,2; = byte anzahl
	brne	set_DMX_START_ADDRESS_fehler
	ldi	temp1,high(ee_DMX_start_adr)
	ldi	temp0,low(ee_DMX_start_adr); = EEPROM->ziel pointer 
	ldi	xh,high(RDM_Data+0)
	ldi	xl,low(RDM_Data+0); = quell Byte pointer
	rcall	EEPROM_write 

	;new DMX-adr sofort ubernehmen
	lds	temp1,RDM_Data+0
	lds	temp0,RDM_Data+1
	sts	dmx_start_adr+0,temp0
	sts	dmx_start_adr+1,temp1

set_DMX_START_ADDRESS_end:
	rjmp	RDM_response_CmdCls_PDLen_break_PortID
set_DMX_START_ADDRESS_fehler:
	ret
;*** DMX_START_ADDRESS
DMX_START_ADDRESS:;(20 00F0)
	ldi	temp3,2; = byte anzahl
	ldi	temp1,high(ee_DMX_start_adr)
	ldi	temp0,low(ee_DMX_start_adr); = EEPROM->quell pointer 
	ldi	xh,high(RDM_Data+0)
	ldi	xl,low(RDM_Data+0); = ziel Byte pointer
	sts	RDM_PDLen,temp3;ParamMsg
	rcall	EEPROM_read
	rjmp	RDM_response_CmdCls_PDLen_break
;*** SUPPORTED_PARAMETERS
SUPPORTED_PARAMETERS:;(20 0050)
	ldi	temp3,1
	ldi	temp1,high(ee_SUPPORTED_PARAMETERS_len)
	ldi	temp0,low(ee_SUPPORTED_PARAMETERS_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen) ;RDM_Data = ziel Byte pointer
	rcall	EEPROM_read

	lds	temp3,RDM_PDLen;bytes

	ldi	temp1,high(ee_SUPPORTED_PARAMETERS)
	ldi	temp0,low(ee_SUPPORTED_PARAMETERS); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_Data);RDM_Data
	ldi	xl,low(RDM_Data) ;RDM_Data = ziel Byte pointer
	rcall	EEPROM_read

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** DEVICE_LABEL
DEVICE_LABEL:;(20 0082)
	ldi	temp3,32+1; = byte anzahl
	ldi	temp1,high(ee_DEVICE_LABEL_len)
	ldi	temp0,low(ee_DEVICE_LABEL_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen); RDM_Data; = ziel Byte pointer
	rcall	EEPROM_read

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** set_DEVICE_LABEL
set_DEVICE_LABEL:;(30 0082)
	lds	temp3,RDM_PDLen;ParamMsg
	cpi	temp3,0; >= byte anzahl
	breq	set_DEVICE_LABEL_end
	cpi	temp3,32+1
	brlo	set_DEVICE_LABEL_ok
	ldi	temp3,32;max
set_DEVICE_LABEL_ok:
	inc	temp3;auch lnge save

	ldi	temp1,high(ee_DEVICE_LABEL_len)
	ldi	temp0,low(ee_DEVICE_LABEL_len); = EEPROM->ziel pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen) ;RDM_Data = quell Byte pointer
	rcall	EEPROM_write

	ldi	temp1,0x00
	sts	RDM_PDLen,temp1
set_DEVICE_LABEL_end:
	rjmp	RDM_response_CmdCls_PDLen_break_PortID

;***************************************************
.if RDM_Befehls_ID_max==1
;***************************************************

;*** MANUFACT_LABEL
MANUFACT_LABEL:;(20 0081)
	ldi	temp3,32+1; = byte anzahl
	ldi	temp1,high(ee_MANUFACT_LABEL_len)
	ldi	temp0,low(ee_MANUFACT_LABEL_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen); RDM_Data; = ziel Byte pointer
	rcall	EEPROM_read

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** set_MANUFACT_LABEL
set_MANUFACT_LABEL:;(30 0081)
	lds	temp3,RDM_PDLen;ParamMsg
	cpi	temp3,0; >= byte anzahl
	breq	set_MANUFACT_LABEL_end
	cpi	temp3,32+1
	brlo	set_MANUFACT_LABEL_ok
	ldi	temp3,32;max
set_MANUFACT_LABEL_ok:
	inc	temp3;mit PDLen

	ldi	temp1,high(ee_MANUFACT_LABEL_len)
	ldi	temp0,low(ee_MANUFACT_LABEL_len); = EEPROM->ziel pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen) ;RDM_Data = quell Byte pointer
	rcall	EEPROM_write

	ldi	temp1,0x00
	sts	RDM_PDLen,temp1
set_MANUFACT_LABEL_end:
	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** set_SUPPORTED_PARAMETERS
set_PSUPPORTED_ARAMETERS:;(30 5000)
	rjmp	PID_not_supported
;*** SOFTWARE_VERSION_LABEL
SOFTWARE_VERSION_LABEL:;(20 0x00C0)
	ldi	temp3,32+1; = byte anzahl
	ldi	temp1,high(ee_SOFTWARE_VERSION_LABEL_len)
	ldi	temp0,low(ee_SOFTWARE_VERSION_LABEL_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen); RDM_Data; = ziel Byte pointer
	rcall	EEPROM_read

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** set SOFTWARE_VERSION_LABEL
set_SOFTWARE_VERSION_LABEL:;(30 0x00C0)
	lds	temp3,RDM_PDLen;ParamMsg
	cpi	temp3,0; >= byte anzahl
	breq	set_SOFTWARE_VERSION_LABEL_end
	cpi	temp3,32+1
	brlo	set_SOFTWARE_VERSION_LABEL_ok
	ldi	temp3,32;max
set_SOFTWARE_VERSION_LABEL_ok:
	inc	temp3;auch lnge save

	ldi	temp1,high(ee_SOFTWARE_VERSION_LABEL_len)
	ldi	temp0,low(ee_SOFTWARE_VERSION_LABEL_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen); RDM_Data; = ziel Byte pointer
	rcall	EEPROM_write

	ldi	temp1,0x00
	sts	RDM_PDLen,temp1
set_SOFTWARE_VERSION_LABEL_end:
	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** get STATUS_ID_DESCRIPTION
get_STATUS_ID_DESCRIPTION:
	ldi	temp3,32+1; = byte anzahl
	ldi	temp1,high(ee_STATUS_ID_DESCRIPTION_len)
	ldi	temp0,low(ee_STATUS_ID_DESCRIPTION_len); = EEPROM->quelle pointer 
	ldi	xh,high(RDM_PDLen);RDM_Data
	ldi	xl,low(RDM_PDLen); RDM_Data; = ziel Byte pointer
	rcall	EEPROM_read

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** get STATUS_MESSAGES
get_STATUS_MESSAGES:
	ldi	temp1,0x00;high NR_STATUS_MESSAGES
	ldi	temp0,0x00;low  NR_STATUS_MESSAGES
	sts	RDM_Data+0,temp1
	sts	RDM_Data+1,temp0

	ldi	temp1,2
	sts	RDM_PDLen,temp1

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** get SENSOR_VALUE (0x0201)
get_SENSOR_VALUE:;SENSOR_VALUE (0x0201)
	lds	temp0,RDM_Data+0;sensor#

;	rcall	read_sensor_daten ;RDM_Data+1,2 Present|3,4 LO|5,6 HI|7,8 Record	
	ldi	temp3,9;lnge
	sts	RDM_PDLen,temp3;ParamMsg

;	ldi	temp0,0
;	ldi	temp1,1
;	sts	RDM_Data+1,temp1
;	sts	RDM_Data+2,temp0



	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** get IDENTIFY
get_IDENTIFY:
	ldi	temp0,0x00;IDENTIFY flag
	lds	temp1,RDM_status
	sbrc	temp1,6
	ldi	temp0,0x01;IDENTIFY flag

	sts	RDM_Data+0,temp0

	ldi	temp1,1
	sts	RDM_PDLen,temp1

	rjmp	RDM_response_CmdCls_PDLen_break_PortID
;*** set IDENTIFY
set_IDENTIFY:
	lds	temp0,RDM_Data+0
	cpi	temp0,00
	breq	set_IDENTIFY_clr_flag
	cpi	temp0,01
	brne	set_IDENTIFY_flag_end
	;IDENTIFY_set_flag
	lds	temp1,RDM_status
	sbr	temp1,64;IDENTIFY on
	sts	RDM_status,temp1
	rjmp	set_IDENTIFY_flag_end
set_IDENTIFY_clr_flag:
	;IDENTIFY_clr_flag
	lds	temp1,RDM_status
	cbr	temp1,64;IDENTIFY off
	sts	RDM_status,temp1
set_IDENTIFY_flag_end:

	ldi	temp1,0
	sts	RDM_PDLen,temp1

	rjmp	RDM_response_CmdCls_PDLen_break_PortID

;************************************************
.endif ;RDM_Befehls_ID_max
;*************************************************

PID_not_supported:;RESPONSE_TYPE_NACK_REASON
	ldi	temp1,0x00;high NR_UNKNOWN_PID
	ldi	temp0,0x00;low  NR_UNKNOWN_PID
	sts	RDM_Data+0,temp1
	sts	RDM_Data+1,temp0

	ldi	temp1,2
	sts	RDM_PDLen,temp1

	ldi	temp0,0x02;RESPONSE_TYPE_NACK (0x02)
	sts	RDM_PortID,temp0

	rjmp	RDM_response_CmdCls_PDLen_break

;*** end RDM_Befehls ***
;************************************************
RDM_response_CmdCls_PDLen_Break_PortID:
	ldi	temp0,0x00;RESPONSE_TYPE_ACK (0x00)
	sts	RDM_PortID,temp0
RDM_response_CmdCls_PDLen_Break:
	;* RDM Break ???
	lds	temp0,DMX_RDM_status
	sbr	temp0,4;Bit 2  RDM mit Break
	sts	DMX_RDM_status,temp0
RDM_response_CmdCls_PDLen:
	;set RDM_CmdCls fr response
	lds	temp0,RDM_CmdCls
	inc	temp0
	sts	RDM_CmdCls,temp0
	;RDM_Length=RDM_Length+RDM_PDLen
	ldi	temp0,24
	lds	temp1,RDM_PDLen
	add	temp0,temp1
	sts	RDM_Length,temp0
RDM_response:
	;* adr Swap (RDM_DestID<>RDM_SrcID)
	ldi	xl,low(RDM_DestID)
	ldi	xh,high(RDM_DestID)
	ldi	yl,low(RDM_SrcID)
	ldi	yh,high(RDM_SrcID)
	ldi	temp2,6
RDM_response_adr_rep:
	ld	temp0,x
	ld	temp1,y
	st	y+,temp0
	st	x+,temp1
	dec	temp2
	brne	RDM_response_adr_rep

	rcall	check_sum
	; check_sum an RDM_Packet anhngen 
	st	x+,temp5;hi
	st	x+,temp4;lo
	subi	temp2,-2;;anzahl byte+cs
	sts	response_counter,temp2

	;* TX-out response
	ldi	temp0,low(RDM_Packet)
	sts	response_pointer+0,temp0
	ldi	temp0,high(RDM_Packet)
	sts	response_pointer+1,temp0
	
	;starte response
	ldi	temp0,RDM_response_delay;delay 179.2s ->TX
	sts	RDM_timer_delay,temp0

	ret
;*************************************************
;*** test Gerte adr auf 0xFF ***
;rcall	test_UID_adr_FF;set Zero Flag wenn ok
test_UID_adr_FF:
	ldi	xl,low(RDM_DestID+0);RDM_Packet
	ldi	xh,high(RDM_DestID+0);RDM_Packet
	ldi	temp2,6;;bytes zu vergleichen
test_UID_adr_FF_rep:
	ld	temp4,x+
	cpi	temp4,0xFF
	brne	test_UID_adr_no_FF	
	dec	temp2
	brne	test_UID_adr_FF_rep
test_UID_adr_no_FF:
	ret	;OK temp2=0 Flag Z adr=FF FF FF FF FF FF FF
;************************************************
;*** test Gerte adr auf UID_adr ***
;rcall	test_UID_adr;set Zero Flag wenn ok
test_UID_adr:
	ldi	xl,low(RDM_DestID+0);RDM_Packet
	ldi	xh,high(RDM_DestID+0);RDM_Packet
	ldi	yl,low(UID_adr_mem+0);Gerte ADR
	ldi	yh,high(UID_adr_mem+0);Gerte ADR
	ldi	temp2,6;;bytes zu vergleichen
test_UID_adr_rep:
	ld	temp4,x+
	ld	temp1,y+
	cp	temp4,temp1
	brne	test_UID_adr_no	
	dec	temp2
	brne	test_UID_adr_rep
test_UID_adr_no:
	ret; OK temp2=0 und Z Flag 
;*************************************************
;check sum LOW  temp4
;check sum high temp5
;RDM_Length	temp2
;RDM_Packet P.  x
check_sum:
	ldi	xl,low(RDM_Packet)
	ldi	xh,high(RDM_Packet)
	lds	temp2,RDM_Length
	ldi	temp3,0;fr ADC (carry)
	ldi	temp4,0
	ldi	temp5,0
check_sum_rep:
	ld	temp0,x+
	add	temp4,temp0
	adc	temp5,temp3

	dec	temp2
	brne	check_sum_rep
	lds	temp2,RDM_Length

	ret
;***************************************************
RDM_response_TX:
	lds	temp1,response_counter;TX-Counter
	tst	temp1
	brne	RDM_response_TX_daten
	rjmp	RDM_response_TX_end
RDM_response_TX_daten:
	inc	temp1;plus 1

	sbi	port_RE_DE,pin_RE_DE ;TX ->SN75176 (RE,DE)

	lds	temp0,DMX_RDM_status
	sbrc	temp0,2;Bit 2  RDM Break ???
	rjmp	RDM_response_TX_break_on	
	;no Break
	lds	xl,response_pointer+0
	lds	xh,response_pointer+1
	ld	temp0,x+

.if RDM_cpu_select==0 ;Mega88
	sts	UDR0,temp0;starte TX->response
.endif ;RDM_cpu_select==0
.if RDM_cpu_select==1 ;Tiny2313
	out	UDR,temp0;starte TX->response
.endif ;RDM_cpu_select==1

	dec	temp1
	sts	response_counter,temp1;TX-Counter

	sts	response_pointer+0,xl
	sts	response_pointer+1,xh
RDM_response_TX_end:
	ret

RDM_response_TX_break_on:
	;Break
	sts	response_counter,temp1;TX-Counter

.if RDM_cpu_select==0 ;Mega88
	ldi	temp0,0 
	sts	UBRR0H,temp0
	ldi	temp0,24	;baund 45.5kbound by 20Mhz
	sts	UBRR0L,temp0
	ldi	temp0,0	;Break Byte
	sts	UDR0,temp0;starte TX->Break response
.endif ;RDM_cpu_select==0
.if RDM_cpu_select==1 ;Tiny2313
	ldi	temp0,0 
	out	UBRRH,temp0
	ldi	temp0,24	;baund 45.5kbound by 20Mhz
	out	UBRRL,temp0
	ldi	temp0,0	;Break Byte
	out	UDR,temp0;starte TX->Break response
.endif ;RDM_cpu_select==1

	ret
;**************************************************
DMX_RDM_INI:
	;*** UID_adr ***
	ldi	temp3,6; = byte anzahl
	ldi	temp1,high(ee_UID_adr)
	ldi	temp0,low(ee_UID_adr); = EEPROM->quelle pointer 
	ldi	xh,high(UID_adr_mem);RDM_Data
	ldi	xl,low(UID_adr_mem); RDM_Data; = ziel Byte pointer
	rcall	EEPROM_read

	;* hole aus EEROM DMX-start-adr
	ldi	temp3,1
	ldi	temp0,low(ee_DMX_start_adr+1);erst LO
	ldi	temp1,high(ee_DMX_start_adr+1)
	ldi	xl,low(dmx_start_adr)
	ldi	xh,high(dmx_start_adr)
	rcall	EEPROM_read
	ldi	temp3,1
	ldi	temp0,low(ee_DMX_start_adr+0);HI
	ldi	temp1,high(ee_DMX_start_adr+0)
	rcall	EEPROM_read

	;* hole aus EEROM dmx_footprint
	ldi	temp3,1
	ldi	temp0,low(ee_dmx_footprint_adr+1);;nur lo Byte
	ldi	temp1,high(ee_dmx_footprint_adr+1)
	ldi	xl,low(dmx_footprint_adr)
	ldi	xh,high(dmx_footprint_adr)
	rcall	EEPROM_read

	rcall	ini_DMXin

	cbi	port_RE_DE,pin_RE_DE ;RX ->SN75176 (RE,DE)

	ret
;***************************************************
RDM_USART_RXC: 	;USART, RX Complete Handler
	push	s
        in      s,sreg
	push	s

	push	temp0
	push	temp1
	push	temp2
	push	xl
	push	xh

.if RDM_cpu_select==0 ;Mega88
	lds	temp2,ucsr0a	; Read UART Fehler Flags 
.endif
.if RDM_cpu_select==1 ;Tiny2313
	in	temp2,ucsra	; Read UART Fehler Flags 
.endif

        sbrc    temp2,4         ; RS Fehler ? FEn: Frame Error
        rjmp    rx_error
		
.if RDM_cpu_select==0 ;Mega88
        lds     temp2,UDR0        ;RS IN DMX/RDM
.endif
.if RDM_cpu_select==1 ;Tiny2313
        in      temp2,UDR        ;RS IN DMX/RDM
.endif

	sei

	clr	temp0
	sts	dmx_time_out,temp0

	lds	temp0,DMX_RDM_status
	cbr	temp0,1;Bit 0  time_out_dmx
	sts	DMX_RDM_status,temp0

	lds	xl,dmx_RDM_lo;DMX adr in counter(RDM Byte in counter)
	lds	xh,dmx_RDM_hi

	;*** DMX<->kein DMX allso anderes
	sbrc	temp0,4;DMX_RDM_status Bit 4->0:DMX 1:kein DMX
	rjmp	ux_ende;->ux_kein_DMX 
	;*** DMX<->RDM ***
	sbrc	temp0,1;DMX_RDM_status Bit 1->0:DMX 1:RDM
	rjmp	ux_RDM ;->zu RDM byte in RDMarray

	;* erste DMX-Byte ??? RDM-byte
	mov	temp1,xl
	or	temp1,xh;teste auf Null 
	brne	ux_DMX ;nicht erste Byte dann DMX ->
	;* Erste Byte DMX oder RDM oder anderes
	cpi	temp2,0x00 ;test Start-Byte 0x00 fr DMX 
	breq	ux_DMX;DMX 

	cpi	temp2,0xcc ;test Start-Byte 0xCC fr RDM(SC_RDM) 
	brne	ux_kein_dmx;kein RDM dann anderes

	sbr	temp0,2;Bit 1  RDM on fr RDMstring
	sts	DMX_RDM_status,temp0
	;* INI RDM-speicher(RDM_puffer)
        ldi     temp0,low(RDM_puffer);pointer auf RDMmem setzen
        ldi     temp1,high(RDM_puffer)
        sts     DMX_RDM_ram_adr,temp0;pointer lo
        sts     DMX_RDM_ram_adr+1,temp1;pointer hi

	rjmp	ux_RDM ;RDM-Byte->RDM_buffer
	;*** kein DMX *************
ux_kein_dmx:
	lds	temp0,DMX_RDM_status
	sbr	temp0,16;Bit 4  kein DMX,RDM ->anderes
	sts	DMX_RDM_status,temp0
	rjmp	ux_ende	
	;*** DMX *******************
ux_DMX:
	;*** Gerte-start-ADR..ADR+Kanle
	lds	temp0,dmx_adr_lo
        cpse    xl,temp0           ;adress vergleich lo
        rjmp    ux_inc_adr
	lds	temp1,dmx_adr_hi
        cpse    xh,temp1           ;adress vergleich hi
        rjmp    ux_inc_adr
	;*** DMX-wert speichern	
	push	yl
	push	yh

        lds     yl,DMX_RDM_ram_adr     ;speicher LO addr holen
        lds     yh,DMX_RDM_ram_adr+1   ;speicher HI addr holen
        st      y+,temp2         ;DMX Daten Speichern
	sts	DMX_RDM_ram_adr,yl     ;speicher LO addr sichern
	sts	DMX_RDM_ram_adr+1,yh   ;speicher HI addr sichern

	pop	yh
	pop	yl

	;* DMX Kanal-counter
	lds	temp2,DMX_RDM_daten_count
	dec	temp2
	sts	DMX_RDM_daten_count,temp2
	breq	ux_inc_adr;schon letzte DMX adr
	;* nchste DMX-Kanal
        adiw    temp1:temp0,1;adresse + 1
        sts     dmx_adr_lo,temp0;DMX adr lo 0..512
        sts     dmx_adr_hi,temp1;DMX adr hi 0..512
	;*** next DMX adr
ux_inc_adr:
	;* ux_inc_adr
	adiw	xh:xl,1	     ;inc 0..512.. DMX-Counter
	sts	dmx_RDM_lo,xl    ;DMX-Counter ->mem	
	sts	dmx_RDM_hi,xh
	breq	ux_kein_dmx
ux_ende:
	cli

	pop	xh
	pop	xl
	pop	temp2
	pop	temp1
	pop	temp0
	
	pop	s
        out     sreg,s
	pop	s
        reti
	;*** DMX,RDM error ini ******************************      
rx_error:
.if RDM_cpu_select==0 ;Mega88
        lds     temp2,UDR0
.endif
.if RDM_cpu_select==1 ;Tiny2313
        in      temp2,UDR        ;RS IN DMX/RDM
.endif

	sei

	;* teste ob DMXadr max stabil 
	;*    sonst +DMX,-DMX vertauscht oder Strung 
	lds	temp0,old_dmx_lo
	lds	temp1,old_dmx_hi
	cp	temp0,xl
	brne	ux_over
	cp	temp1,xh
	brne	ux_over
	;*** DMX OK ->verarbeiten->reset(Break) ********** 	
	sbr	bf_equ,1 ;DMX OK ->verarbeiten
ux_over:
	sts	old_dmx_lo,xl
	sts	old_dmx_hi,xh

ux_ini_DMX:
	rcall	ini_DMXin

	rjmp	ux_ende

;*** RDM **************************************************
ux_RDM:
	;*** RDM-DMX-wert speichern	
;	cpi	xl,1           ;pos_RDM_Length
;	brne	ux_RDM_test2
;	cpi	temp2,0x01;RDM_SSC
;	brne	ux_RDM_fehler
;ux_RDM_test2:
	tst	xh
	brne	ux_RDM_lang_no
	cpi	xl,2           ;pos_RDM_Length
	brne	ux_RDM_no_Length
	cpi	temp2,24;min lnge
	brlo	ux_RDM_lang_no
	cpi	temp2,RDM_data_max ;max lnge
	brlo	ux_RDM_lang_ok
ux_RDM_lang_no:
	rjmp	ux_kein_dmx
ux_RDM_lang_ok:
	sts	DMX_RDM_daten_count,temp2
ux_RDM_no_Length:

	adiw	xh:xl,1
	sts	dmx_RDM_lo,xl;DMX adr in counter(RDM Byte in counter)
	sts	dmx_RDM_hi,xh;DMX adr in counter(RDM Byte in counter)


        lds     xl,DMX_RDM_ram_adr     ;RDM speicher LO addr holen
        lds     xh,DMX_RDM_ram_adr+1   ;RDM speicher HI addr holen
        st      x+,temp2           ;RDM Daten Speichern
	sts	DMX_RDM_ram_adr,xl     ;speicher LO addr sichern
	sts	DMX_RDM_ram_adr+1,xh   ;speicher HI addr sichern

	lds	temp1,DMX_RDM_daten_count
	dec	temp1	;RDM Byte counter
	sts	DMX_RDM_daten_count,temp1
	breq	ux_RDM_end  ;schon letzte RDM Wert

	rjmp	ux_ende
	;*** RDM zur auswertung
ux_RDM_end:
.if RDM_auswertung_Bf_equ==0
	sbr	bf_equ,16
.endif
.if RDM_auswertung_Bf_equ==1
	lds	temp0,bf_LO_mem	;set Flag fr RDM-in
	sbr	temp0,16 ;RDM IN->auswertung
	sts	bf_LO_mem,temp0;bf_LO_mem zurck ins MEM	
.endif
ux_RDM_fehler:
	rjmp	ux_kein_dmx
;*********************************************************

ini_DMXin:
	lds	temp0,DMX_RDM_status
	cbr	temp0,2+4+16;Bit 1 RDM->0ff|Bit 2 RDM-Break off|Bit 4 anderes->off
	sts	DMX_RDM_status,temp0
	; DMXgerte Start adr
	lds	temp0,dmx_start_adr_lo
	lds	temp1,dmx_start_adr_hi
        sts     dmx_adr_lo,temp0;DMXgerte adr lo 1..512
        sts     dmx_adr_hi,temp1;DMXgerte adr hi 1..512
        ; DMX zhler -> 0
        ldi     temp0,0 ;clear DMX/RDM Byte-Counter
	sts	dmx_RDM_lo,temp0;xl
	sts	dmx_RDM_hi,temp0;xh
	; DMX adressen setzen
	lds	temp1,dmx_footprint_adr;DMX adressen
;	inc	temp1  ;DMX adressen + 1
        sts     DMX_RDM_daten_count,temp1;anzahl DMXdaten -> ram
	;* set pointer fr DMX_puffer
        ldi     temp0,low(DMX_puffer)
        ldi     temp1,high(DMX_puffer)
        sts     DMX_RDM_ram_adr,temp0
        sts     DMX_RDM_ram_adr+1,temp1

	ret

;*********************************************************
RDM_USART_TXC: 	;USART, TX Complete Handler
	push	s
        in      s,sreg

	push	temp0

	lds	temp0,DMX_RDM_status
	sbrs	temp0,2;Bit 2 fr Break
	rjmp	USART_TXC_break_end

	cbr	temp0,4;Bit 2  RDM Break OFF
	sts	DMX_RDM_status,temp0

.if RDM_cpu_select==0 ;Mega88
	ldi	temp0,0
	sts	UBRR0H,temp0
	ldi	temp0,4	;baund 250kbound by 20Mhz
	sts	UBRR0L,temp0
.endif
.if RDM_cpu_select==1 ;Tiny2313
	ldi	temp0,0
	out	UBRRH,temp0
	ldi	temp0,4	;baund 250kbound by 20Mhz
	out	UBRRL,temp0
.endif
	

USART_TXC_break_end:

	lds	temp0,response_counter
	dec	temp0
	sts	response_counter,temp0
	breq	USART_TXC_end	


	push	xl
	push	xh
	lds	xl,response_pointer+0
	lds	xh,response_pointer+1
	ld	temp0,x+

.if RDM_cpu_select==0 ;Mega88
        sts     UDR0,temp0
.endif
.if RDM_cpu_select==1 ;Tiny2313
        out     UDR,temp0
.endif

	sts	response_pointer+0,xl
	sts	response_pointer+1,xh
	pop	xh
	pop	xl

	rjmp	USART_TXC_ende

USART_TXC_end:
	cbi	port_RE_DE,pin_RE_DE ;RX ->SN75176 (RE,DE)

USART_TXC_ende:
	pop	temp0

        out     sreg,s
	pop	s
        reti
;***************************************************
;***************************************************
;***************************************************
;***************************************************
.if RDM_debug_test==1

RDM_test_array:
	ldi	xl,low(RDM_Packet)
	ldi	xh,high(RDM_Packet)

	ldi	zl,low(RDM_test_Packet*2)
	ldi	zh,high(RDM_test_Packet*2)

	ldi	temp4,24+2;byte 
RDM_test_array_rep:
	LPM 	temp0, Z+
	st	x+,temp0	

	dec	temp4
	brne	RDM_test_array_rep

	ret

.endif ;RDM_debug_test























