;*** EEPROM R/W mit 2313 ***

;*** EEPROM write ***
;temp3 = byte anzahl
;xh:xl = quelle Byte pointer
;temp0 = ziel pointer -> EEPROM

EEPROM_write:

EEPROM_write_rep:
	ld	temp2,x+;daten in temp2	
	wdr
EEPROM_write_wait:
; Wait for completion of previous write
	sbic	EECR,EEPE	;if EEWE not clear EEWE	= EEPE
	rjmp	EEPROM_write_wait;wait more

	cli
	out	EEAR,temp0	;output address
	out	EEDR,temp2	;output data
	sbi	EECR,EEMPE	;set EEPROM master Write strobe
	sbi	EECR,EEPE	;set EEPROM Write strobe
	sei

	inc	temp0		;nchste eerom adr
	dec	temp3
	brne	EEPROM_write_rep;noch ein wert ?

	ret

;*******************************************
;*** EEPROM read ***
;temp3 = byte anzahl
;temp0 = EEPROM->quelle pointer 
;xh:xl = ziel Byte pointer

EEPROM_read:

EEPROM_read_rep:
EEPROM_read_wait:
; Wait for completion of previous write
	sbic	EECR,EEPE    ;if EEWE not clear EEWE = EEPE
	rjmp	EEPROM_read_wait;    wait more

	out	EEAR,temp0  ;output address
	sbi	EECR,EERE   ;set EEPROM Read strobe
	in	temp2,EEDR	;get data
	st	x+,temp2	;in RAM-speicher

	inc	temp0		;nchste eerom adr
	dec	temp3
	brne	EEPROM_read_rep;noch ein wert ?

	ret

